Package org.apache.commons.compress.archivers.zip

# Class ZipFile

java.lang.Object
org.apache.commons.compress.archivers.zip.ZipFile

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class ZipFile extends Object implements Closeable
Replacement for `ZipFile`.

This class adds support for file name encodings other than UTF-8 (which is required to work on ZIP files created by native ZIP tools and is able to skip a preamble like the one found in self extracting archives. Furthermore it returns instances of `org.apache.commons.compress.archivers.zip.ZipArchiveEntry` instead of `ZipEntry`.

It doesn't extend `ZipFile` as it would have to reimplement all methods anyway. Like `ZipFile`, it uses SeekableByteChannel under the covers and supports compressed and uncompressed entries. As of Apache Commons Compress 1.3 it also transparently supports Zip64 extensions and thus individual entries and archives larger than 4 GB or with more than 65,536 entries.

The method signatures mimic the ones of `ZipFile`, with a couple of exceptions:

- There is no getName method.
- entries has been renamed to getEntries.
- getEntries and getEntry return `org.apache.commons.compress.archivers.zip.ZipArchiveEntry` instances.
- close is allowed to throw IOException.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `ZipFile.Builder`
  Builds new `ZipFile` instances.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ZipFile(File file)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(File file, String encoding)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(File file, String encoding, boolean useUnicodeExtraFields)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(File file, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(String name)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(String name, String encoding)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(SeekableByteChannel channel)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(SeekableByteChannel channel, String encoding)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(SeekableByteChannel channel, String channelDescription, String encoding, boolean useUnicodeExtraFields)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(SeekableByteChannel channel, String channelDescription, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(Path path)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(Path path, String encoding)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(Path path, String encoding, boolean useUnicodeExtraFields)`
  Deprecated.
  Use `ZipFile.Builder.get()`.
  `ZipFile(Path path, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader)`
  Deprecated.
  Use `ZipFile.Builder.get()`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ZipFile.Builder`
  `builder()`
  Creates a new Builder.
  `boolean`
  `canReadEntryData(ZipArchiveEntry entry)`
  Tests whether this class is able to read the given entry.
  `void`
  `close()`
  Closes the archive.
  `static void`
  `closeQuietly(ZipFile zipFile)`
  Closes a ZIP file quietly; throwing no IOException, does nothing on null input.
  `void`
  `copyRawEntries(ZipArchiveOutputStream target, ZipArchiveEntryPredicate predicate)`
  Transfer selected entries from this ZIP file to a given #ZipArchiveOutputStream.
  `protected void`
  `finalize()`
  Ensures that the close method of this ZIP file is called when there are no more references to it.
  `InputStream`
  `getContentBeforeFirstLocalFileHeader()`
  Gets an InputStream for reading the content before the first local file header.
  `String`
  `getEncoding()`
  Gets the encoding to use for file names and the file comment.
  `Enumeration<ZipArchiveEntry>`
  `getEntries()`
  Gets all entries.
  `Iterable<ZipArchiveEntry>`
  `getEntries(String name)`
  Gets all named entries in the same order they appear within the archive's central directory.
  `Enumeration<ZipArchiveEntry>`
  `getEntriesInPhysicalOrder()`
  Gets all entries in physical order.
  `Iterable<ZipArchiveEntry>`
  `getEntriesInPhysicalOrder(String name)`
  Gets all named entries in the same order their contents appear within the archive.
  `ZipArchiveEntry`
  `getEntry(String name)`
  Gets a named entry or `null` if no entry by that name exists.
  `long`
  `getFirstLocalFileHeaderOffset()`
  Gets the offset of the first local file header in the file.
  `InputStream`
  `getInputStream(ZipArchiveEntry entry)`
  Gets an InputStream for reading the contents of the given entry.
  `InputStream`
  `getRawInputStream(ZipArchiveEntry entry)`
  Gets the raw stream of the archive entry (compressed form).
  `String`
  `getUnixSymlink(ZipArchiveEntry entry)`
  Gets the entry's content as a String if isUnixSymlink() returns true for it, otherwise returns null.
  `IOStream<? extends ZipArchiveEntry>`
  `stream()`
  Returns an ordered `Stream` over the ZIP file entries.

  ### Methods inherited from class java.lang.Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ZipFile

    @Deprecated public ZipFile(File file) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming "UTF8" for file names.
    Parameters:
      `file` - the archive.
    Throws:
      `IOException` - if an error occurs while reading the file.

  - ### ZipFile

    @Deprecated public ZipFile(File file, String encoding) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming the specified encoding for file names and scanning for Unicode extra fields.
    Parameters:
      `file` - the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
    Throws:
      `IOException` - if an error occurs while reading the file.

  - ### ZipFile

    @Deprecated public ZipFile(File file, String encoding, boolean useUnicodeExtraFields) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming the specified encoding for file names.
    Parameters:
      `file` - the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
    Throws:
      `IOException` - if an error occurs while reading the file.

  - ### ZipFile

    @Deprecated public ZipFile(File file, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming the specified encoding for file names.

    By default the central directory record and all local file headers of the archive will be read immediately which may take a considerable amount of time when the archive is big. The `ignoreLocalFileHeader` parameter can be set to `true` which restricts parsing to the central directory. Unfortunately the local file header may contain information not present inside of the central directory which will not be available when the argument is set to `true`. This includes the content of the Unicode extra field, so setting `ignoreLocalFileHeader` to `true` means `useUnicodeExtraFields` will be ignored effectively.

    Parameters:
      `file` - the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
      `ignoreLocalFileHeader` - whether to ignore information stored inside the local file header (see the notes in this method's Javadoc)
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.19

  - ### ZipFile

    @Deprecated public ZipFile(Path path) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given path for reading, assuming "UTF-8" for file names.
    Parameters:
      `path` - path to the archive.
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.22

  - ### ZipFile

    @Deprecated public ZipFile(Path path, String encoding) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given path for reading, assuming the specified encoding for file names and scanning for Unicode extra fields.
    Parameters:
      `path` - path to the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.22

  - ### ZipFile

    @Deprecated public ZipFile(Path path, String encoding, boolean useUnicodeExtraFields) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given path for reading, assuming the specified encoding for file names.
    Parameters:
      `path` - path to the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.22

  - ### ZipFile

    @Deprecated public ZipFile(Path path, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given path for reading, assuming the specified encoding for file names.

    By default the central directory record and all local file headers of the archive will be read immediately which may take a considerable amount of time when the archive is big. The `ignoreLocalFileHeader` parameter can be set to `true` which restricts parsing to the central directory. Unfortunately the local file header may contain information not present inside of the central directory which will not be available when the argument is set to `true`. This includes the content of the Unicode extra field, so setting `ignoreLocalFileHeader` to `true` means `useUnicodeExtraFields` will be ignored effectively.

    Parameters:
      `path` - path to the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
      `ignoreLocalFileHeader` - whether to ignore information stored inside the local file header (see the notes in this method's Javadoc)
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.22

  - ### ZipFile

    @Deprecated public ZipFile(SeekableByteChannel channel) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given channel for reading, assuming "UTF-8" for file names.

    `SeekableInMemoryByteChannel` allows you to read from an in-memory archive.

    Parameters:
      `channel` - the archive.
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.13

  - ### ZipFile

    @Deprecated public ZipFile(SeekableByteChannel channel, String encoding) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given channel for reading, assuming the specified encoding for file names.

    `SeekableInMemoryByteChannel` allows you to read from an in-memory archive.

    Parameters:
      `channel` - the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.13

  - ### ZipFile

    @Deprecated public ZipFile(SeekableByteChannel channel, String channelDescription, String encoding, boolean useUnicodeExtraFields) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given channel for reading, assuming the specified encoding for file names.

    `SeekableInMemoryByteChannel` allows you to read from an in-memory archive.

    Parameters:
      `channel` - the archive.
      `channelDescription` - description of the archive, used for error messages only.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.13

  - ### ZipFile

    @Deprecated public ZipFile(SeekableByteChannel channel, String channelDescription, String encoding, boolean useUnicodeExtraFields, boolean ignoreLocalFileHeader) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given channel for reading, assuming the specified encoding for file names.

    `SeekableInMemoryByteChannel` allows you to read from an in-memory archive.

    By default the central directory record and all local file headers of the archive will be read immediately which may take a considerable amount of time when the archive is big. The `ignoreLocalFileHeader` parameter can be set to `true` which restricts parsing to the central directory. Unfortunately the local file header may contain information not present inside of the central directory which will not be available when the argument is set to `true`. This includes the content of the Unicode extra field, so setting `ignoreLocalFileHeader` to `true` means `useUnicodeExtraFields` will be ignored effectively.

    Parameters:
      `channel` - the archive.
      `channelDescription` - description of the archive, used for error messages only.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
      `useUnicodeExtraFields` - whether to use InfoZIP Unicode Extra Fields (if present) to set the file names.
      `ignoreLocalFileHeader` - whether to ignore information stored inside the local file header (see the notes in this method's Javadoc)
    Throws:
      `IOException` - if an error occurs while reading the file.
    Since:
      1.19

  - ### ZipFile

    @Deprecated public ZipFile(String name) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming "UTF-8".
    Parameters:
      `name` - name of the archive.
    Throws:
      `IOException` - if an error occurs while reading the file.

  - ### ZipFile

    @Deprecated public ZipFile(String name, String encoding) throws IOException
    Deprecated.
    Use `ZipFile.Builder.get()`.
    Opens the given file for reading, assuming the specified encoding for file names, scanning unicode extra fields.
    Parameters:
      `name` - name of the archive.
      `encoding` - the encoding to use for file names, use null for the platform's default encoding
    Throws:
      `IOException` - if an error occurs while reading the file.

- ## Method Details

  - ### builder

    public static ZipFile.Builder builder()
    Creates a new Builder.
    Returns:
      a new Builder.
    Since:
      1.26.0

  - ### closeQuietly

    public static void closeQuietly(ZipFile zipFile)
    Closes a ZIP file quietly; throwing no IOException, does nothing on null input.
    Parameters:
      `zipFile` - file to close, can be null

  - ### canReadEntryData

    public boolean canReadEntryData(ZipArchiveEntry entry)
    Tests whether this class is able to read the given entry.

    May return false if it is set up to use encryption or a compression method that hasn't been implemented yet.

    Parameters:
      `entry` - the entry
    Returns:
      whether this class is able to read the given entry.
    Since:
      1.1

  - ### close

    public void close() throws IOException
    Closes the archive.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Throws:
      `IOException` - if an error occurs closing the archive.

  - ### copyRawEntries

    public void copyRawEntries(ZipArchiveOutputStream target, ZipArchiveEntryPredicate predicate) throws IOException
    Transfer selected entries from this ZIP file to a given #ZipArchiveOutputStream. Compression and all other attributes will be as in this file.

    This method transfers entries based on the central directory of the ZIP file.

    Parameters:
      `target` - The zipArchiveOutputStream to write the entries to
      `predicate` - A predicate that selects which entries to write
    Throws:
      `IOException` - on error

  - ### finalize

    protected void finalize() throws Throwable
    Ensures that the close method of this ZIP file is called when there are no more references to it.
    Overrides:
      `finalize` in class `Object`
    Throws:
      `Throwable`
    See Also:
      - `close()`

  - ### getContentBeforeFirstLocalFileHeader

    public InputStream getContentBeforeFirstLocalFileHeader()
    Gets an InputStream for reading the content before the first local file header.
    Returns:
      null if there is no content before the first local file header. Otherwise, returns a stream to read the content before the first local file header.
    Since:
      1.23

  - ### getEncoding

    public String getEncoding()
    Gets the encoding to use for file names and the file comment.
    Returns:
      null if using the platform's default character encoding.

  - ### getEntries

    public Enumeration<ZipArchiveEntry> getEntries()
    Gets all entries.

    Entries will be returned in the same order they appear within the archive's central directory.

    Returns:
      all entries as `ZipArchiveEntry` instances

  - ### getEntries

    public Iterable<ZipArchiveEntry> getEntries(String name)
    Gets all named entries in the same order they appear within the archive's central directory.
    Parameters:
      `name` - name of the entry.
    Returns:
      the Iterable<ZipArchiveEntry> corresponding to the given name
    Since:
      1.6

  - ### getEntriesInPhysicalOrder

    public Enumeration<ZipArchiveEntry> getEntriesInPhysicalOrder()
    Gets all entries in physical order.

    Entries will be returned in the same order their contents appear within the archive.

    Returns:
      all entries as `ZipArchiveEntry` instances
    Since:
      1.1

  - ### getEntriesInPhysicalOrder

    public Iterable<ZipArchiveEntry> getEntriesInPhysicalOrder(String name)
    Gets all named entries in the same order their contents appear within the archive.
    Parameters:
      `name` - name of the entry.
    Returns:
      the Iterable<ZipArchiveEntry> corresponding to the given name
    Since:
      1.6

  - ### getEntry

    public ZipArchiveEntry getEntry(String name)
    Gets a named entry or `null` if no entry by that name exists.

    If multiple entries with the same name exist the first entry in the archive's central directory by that name is returned.

    Parameters:
      `name` - name of the entry.
    Returns:
      the ZipArchiveEntry corresponding to the given name - or `null` if not present.

  - ### getFirstLocalFileHeaderOffset

    public long getFirstLocalFileHeaderOffset()
    Gets the offset of the first local file header in the file.
    Returns:
      the length of the content before the first local file header
    Since:
      1.23

  - ### getInputStream

    public InputStream getInputStream(ZipArchiveEntry entry) throws IOException
    Gets an InputStream for reading the contents of the given entry.
    Parameters:
      `entry` - the entry to get the stream for.
    Returns:
      a stream to read the entry from. The returned stream implements `InputStreamStatistics`.
    Throws:
      `IOException` - if unable to create an input stream from the zipEntry.

  - ### getRawInputStream

    public InputStream getRawInputStream(ZipArchiveEntry entry) throws IOException
    Gets the raw stream of the archive entry (compressed form).

    This method does not relate to how/if we understand the payload in the stream, since we really only intend to move it on to somewhere else.

    Since version 1.22, this method will make an attempt to read the entry's data stream offset, even if the `ignoreLocalFileHeader` parameter was `true` in the constructor. An IOException can also be thrown from the body of the method if this lookup fails for some reason.

    Parameters:
      `entry` - The entry to get the stream for
    Returns:
      The raw input stream containing (possibly) compressed data.
    Throws:
      `IOException` - if there is a problem reading data offset (added in version 1.22).
    Since:
      1.11

  - ### getUnixSymlink

    public String getUnixSymlink(ZipArchiveEntry entry) throws IOException
    Gets the entry's content as a String if isUnixSymlink() returns true for it, otherwise returns null.

    This method assumes the symbolic link's file name uses the same encoding that as been specified for this ZipFile.

    Parameters:
      `entry` - ZipArchiveEntry object that represents the symbolic link
    Returns:
      entry's content as a String
    Throws:
      `IOException` - problem with content's input stream
    Since:
      1.5

  - ### stream

    public IOStream<? extends ZipArchiveEntry> stream()
    Returns an ordered `Stream` over the ZIP file entries.

    Entries appear in the `Stream` in the order they appear in the central directory of the ZIP file.

    Returns:
      an ordered `Stream` of entries in this ZIP file.
    Throws:
      `IllegalStateException` - if the ZIP file has been closed.
    Since:
      1.28.0